#include"DTime.h"
#ifndef WIN32
#include<sys/time.h>
#endif /* !WIN32 */
#ifdef LINUX
#include <cstdio>
#endif
#ifdef __sgi
	#include <stdio.h>
#else
	#include <cstdio>
    using namespace std;
#endif

DTime::DTime( int usec )
{
    m_start = 0;
    m_usec = usec;
}

DTime::DTime( int sec, int usec )
{
    m_start = 0;
    m_usec = 1000000 * sec + usec;
}
DTime::DTime( int min, int sec, int usec )
{
    m_start = 0;
    m_usec = 60000*min + 1000 * sec + usec;
}
DTime::DTime( int hr, int min, int sec, int usec )
{
    m_start = 0;
    m_usec = 3600000*hr + 60000*min + 1000 * sec + usec;
}

#ifdef WIN32
DTime DTime::current()
{
    timeval tv;
    gettimeofday( &tv, NULL );
    return DTime( tv.tv_sec, tv.tv_usec );
}
#else
DTime DTime::current()
{
    timeval tv;
    gettimeofday( &tv, NULL );
    return DTime( tv.tv_sec, tv.tv_usec );
}
#endif /* WIN32 */
//=============================================================================
// Function Name: start
///     Starts the timer
//=============================================================================
void DTime::start()
{
    m_start = current().m_usec;
}

//=============================================================================
// Function Name: reset
///     Resets the timer and returns the time since the last reset or start
/// \return time since last reset or start
//=============================================================================
DTime DTime::reset()
{
    DTime tmp = DTime(m_start);
    m_start = current().usec();
    return DTime(m_start - tmp.usec());
}

//=============================================================================
// Function Name: elapsed
/// \return time since last reset or start
//=============================================================================
DTime DTime::elapsed()const
{
    return current() - m_start;
}
