#include"POAddress.h"

bool operator==( const POAddress& a, const POAddress& b )
{
    return a.getPO() == b.getPO() && a.getBox() == b.getBox();
}
bool operator!=( const POAddress& a, const POAddress& b )
{
    return a.getPO() != b.getPO() || a.getBox() != b.getBox();
}
POAddress::POAddress( const string& po, const string& box )
:Packable(),m_po(po), m_box(box)
{
}

POAddress::POAddress( const POAddress& cpy )
:Packable()
{
    m_po = cpy.m_po;
    m_box = cpy.m_box;
}


int POAddress::packsize()const
{
    return m_po.packsize() + m_box.packsize();
}

int POAddress::pack( char* buffer )const
{
    char* tmp = buffer;
    tmp += m_po.pack( tmp );
    tmp += m_box.pack( tmp );
    return tmp - buffer;
}

int POAddress::unpack( char* buffer )
{
    char* tmp = buffer;
    tmp += m_po.unpack(tmp);
    tmp += m_box.unpack(tmp);
    return tmp - buffer;
}
