#include"POBoxListMsg.h"
#include"POMessageFactory.h"

POBoxListMsg::POBoxListMsg( int cmd )
:m_cmd(cmd)
{
   
}

POBoxListMsg::POBoxListMsg( const POBoxListMsg& cpy )
:POMessage((POMessage)cpy), m_cmd(cpy.m_cmd), m_boxes(cpy.m_boxes)
{

}

void POBoxListMsg::addBox( const string& box )
{
    m_boxes.push_back(box);
}

POMessage* POBoxListMsg::clone()const
{
    return new POBoxListMsg( *this );
}

int POBoxListMsg::packsize()const
{
    int size = POMessage::packsize();
    size += m_cmd.packsize();
    size += sizeof(int); // number of boxes
    
    for( unsigned int i = 0; i < m_boxes.size(); i++ )
    {
        POString str(m_boxes[i]);
        size += str.packsize();
    }
    return size;
}

int POBoxListMsg::pack( char* buffer )const
{
    char* tmp = buffer;
    tmp += POMessage::pack(tmp);
    tmp += m_cmd.pack(tmp);
    tmp += POInt(m_boxes.size()).pack(tmp);
    
    for( unsigned int i = 0; i < m_boxes.size(); i++ )
    {
//        POString str(m_boxes[i]);
        tmp += POString(m_boxes[i]).pack(tmp);
    }
    return tmp - buffer;
}

int POBoxListMsg::unpack( char* buffer )
{
    char* tmp = buffer;
    tmp += POMessage::unpack(tmp);
    tmp += m_cmd.unpack(tmp);

    POInt size;
    tmp += size.unpack(tmp);

    POString box;
    for( int i = 0; i < size.val(); i++ )
    {
        tmp += box.unpack(tmp);
        m_boxes.push_back( box );
    }
    return tmp - buffer;
}

