#ifndef _POBOXLISTMSG_H_
#define _POBOXLISTMSG_H_
#include<POMessage.h>
#include<vector> 

class PEXPR_API POBoxListMsg : public POMessage
{
    public:
        enum BOXCMD { NEWBOXES, CLOSEBOXES };
        POBoxListMsg( int cmd = NEWBOXES );
        POBoxListMsg( const POBoxListMsg& cpy );
        virtual ~POBoxListMsg(){}

        string messageType()const { return "POBoxListMsg"; }

        void addBox( const string& box );

        vector<string> getBoxes()const { return m_boxes;      }
        int getCommand()const          { return m_cmd.val();  }

        POMessage* clone()const;

        int packsize()const;
        int pack( char* buffer )const;
        int unpack( char* buffer );
        
    private:
        POInt               m_cmd;
        vector<string>      m_boxes;
};

#endif
