//=============================================================================
// POErrorMsg.h
/// @class POErrorMsg POErrorMsg.h
/// @brief A simple text message
//
// Created 5/13/03 By Daniel Larimer
//=============================================================================
#ifndef _POERRORMSG_H_
#define _POERRORMSG_H_
#include<POMessage.h>
#include<string>
using namespace std;


class PEXPR_API POErrorMsg : public POMessage
{
    public:
        POErrorMsg( const string& txt = "");
        POErrorMsg( const char* format, ... );
        POErrorMsg( const POErrorMsg& cpy );
        virtual ~POErrorMsg();
        virtual string messageType()const { return "POErrorMsg"; };

        string  getText()const{ return m_txt.val(); }
        void    setText( const string& txt );

        virtual POMessage* clone()const;

        //==========================
        // Packable
        //==========================
        int packsize()const;
        int pack( char* buf )const;
        int unpack( char* buf );

    private:
        POString  m_txt;
};

#endif
