//=============================================================================
/// @class POGroup
/// @brief Provides a mailing list where every message sent to the group is sent
///     to all members except the member who initially sent the message
/// @author Daniel Larimer
//=============================================================================
#ifndef _POGROUP_H_
#define _POGROUP_H_
#include<qobject.h>
#include<vector>
#include<string>
#include<POAddress.h>
using namespace std;

class PostOffice;
class POBox;
class POMessage;

class POGroup : public QObject
{
    Q_OBJECT
    public:
        POGroup( const string& name, PostOffice* po );
        ~POGroup();
        
    public slots:
        void handleMessage( const POMessage* msg );
        void addAddress( const POAddress& adr );
        void removeAddress( const POAddress& adr );
        void forward( const POMessage* msg );

    private:
        POBox*              m_inbox;
        PostOffice*         m_po;
        vector<POAddress>   m_members;
};


#endif
