//=============================================================================
// POGroupMsg.h
/// @class POGroupMsg
/// @brief Used to communicate group commands
//
// Created 9/16/03 By Daniel Larimer
//=============================================================================
#ifndef _POGROUPMSG_H_
#define _POGROUPMSG_H_
#include<POMessage.h>
#include<string>
using namespace std;


class PEXPR_API POGroupMsg : public POMessage
{
    public:
        enum COMMAND{JOIN, LEAVE, ADD, REMOVE};
        POGroupMsg( int cmd = JOIN );
        POGroupMsg( const POAddress& add_address, int add_rem = ADD );
        POGroupMsg( const POGroupMsg& cpy );
        virtual ~POGroupMsg();
        virtual string messageType()const { return "POGroupMsg"; };

        int     getCommand()const       { return m_cmd.val(); }
        void    setCommand( int cmd )   { m_cmd = cmd;        }

        /// Only valid if getCommand() == ADD || REMOVE
        /// @return the address to add or remove the group
        POAddress getAddress()const                  { return m_adr; }
        /// Only valid if getCommand() == ADD || REMOVE
        void      setAddress( const POAddress& adr ) { m_adr = adr;  }

        virtual POMessage* clone()const;

        //==========================
        // Packable
        //==========================
        int packsize()const;
        int pack( char* buf )const;
        int unpack( char* buf );

    private:
        POInt       m_cmd;
        POAddress   m_adr;
};

#endif
