//=============================================================================
// POMessage.h
/// @class POMessage POMessage.h
/// @brief The base class for all messages sent through the PostOffice
//
// Created 5/13/03 By Daniel Larimer
//=============================================================================
#ifndef _POMESSAGE_H_
#define _POMESSAGE_H_
#include<Packable.h>
#include<POAddress.h>
#include<POTypes.h>
#include<string>
using namespace std;


class PEXPR_API POMessage : impliments Packable
{
    public:
        POMessage();
        POMessage( const POMessage& cpy );
        virtual ~POMessage();
        virtual string messageType()const { return "POMessage"; };

        void setTag( int id ){ m_tag = id; }
        void setSource( const POAddress& source );
        void setDestination( const POAddress& dest );

        POInt     getTag()const { return m_tag; }
        POAddress getSource()const;
        POAddress getDestination()const;
        string    getPackedType()const{ return m_derivedtype.val(); }

        virtual POMessage* clone()const;

        //==========================
        // Packable
        //==========================
        int packsize()const;
        int pack( char* buf )const;
        int unpack( char* buf );

    private:
        POAddress m_source;
        POAddress m_destination;
        POString  m_derivedtype;
        POInt     m_tag;
};
#include<POMessageFactory.h>
#endif
