#ifndef _POMESSAGEFACTORY_H_
#define _POMESSAGEFACTORY_H_
#include<string>
#include<map>
#include<POMessage.h>
using namespace std;

#ifdef WIN32
#include <windows.h>
#ifdef PEXPR_EXPORTS
#define PEXPR_API __declspec(dllexport)
#else
#define PEXPR_API __declspec(dllimport)
#endif /* PEXPR_EXPORTS */
#else
#define PEXPR_API
#endif /* WIN32 */

class PEXPR_API POMessageFactory
{
    public:
        static void init();
        static bool Register( POMessage* msg );
        static bool UnRegister( const string& type );

        static POMessage* BuildFromBuffer( char* buffer );
        static POMessage* Build( const string& type );

    private:
        static map<string, POMessage*>  *m_messages;
        static bool                      m_init;
};

#endif
