//=============================================================================
// POPartialMsg.h
/// @class POPartialMsg POPartialMsg.h
/// @brief Can only be used internally to send large messages in many parts
//
// Created 5/13/03 By Daniel Larimer
//=============================================================================
#ifndef _POPARTIALMSG_H_
#define _POPARTIALMSG_H_
#include<POMessage.h>
#include<POTypes.h>
#include<string>
using namespace std;


class PEXPR_API POPartialMsg : public POMessage
{
    public:
        POPartialMsg( int num = 0, 
                      int of = 0, 
                      char* buffer = NULL, int size = 0 );
        POPartialMsg( const POPartialMsg& cpy );
        virtual ~POPartialMsg();
        virtual string messageType()const { return "POPartialMsg"; };

        virtual POMessage* clone()const;

        int getBufferSize()const { return m_size.val();   }
        int getNumber()const     { return m_num.val();    }
        int getMaxNum()const     { return m_maxnum.val(); }
        char* getData()const     { return m_buffer;       }
        
        //==========================
        // Packable
        //==========================
        int packsize()const;
        int pack( char* buf )const;
        int unpack( char* buf );

    private:
        char*         m_buffer;
        POInt         m_size;
        POInt         m_num;
        POInt         m_maxnum;
};

#endif
