#ifndef _POSMALLFILEMSG_H_
#define _POSMALLFILEMSG_H_
#include<POMessage.h>
#include<POTypes.h>

class POSmallFileMsg : public POMessage
{
    public:
        POSmallFileMsg( const string& srcname = "",
                        const string& destfile = "");
        POSmallFileMsg( const POSmallFileMsg& cpy );
        virtual ~POSmallFileMsg();
        
        string messageType()const { return "POSmallFileMsg"; }
        POMessage* clone()const;
       
        int packsize()const;
        int pack( char* buffer )const;
        int unpack( char* buffer );
       
        // mutators
        bool    loadFile( const string& fname );
        
        // accessors
        char*   getFileData()const { return m_filedata;       }
        int     getFileSize()const { return m_filesize.val(); } 
        string  getSrcFile()const  { return m_filename.val(); }
        string  getDestFile()const { return m_destfile.val(); }

    private:
        char*           m_filedata;
        POInt           m_filesize;
        POString        m_filename; 
        POString        m_destfile;
};
#endif
