//=============================================================================
// POTextMsg.h
/// @class POTextMsg POTextMsg.h
/// @brief A simple text message
//
// Created 5/13/03 By Daniel Larimer
//=============================================================================
#ifndef _POTEXTMSG_H_
#define _POTEXTMSG_H_
#include<POMessage.h>
#include<string>
using namespace std;


class PEXPR_API POTextMsg : public POMessage
{
    public:
        POTextMsg( const string& txt = "");
        POTextMsg( const POTextMsg& cpy );
        POTextMsg( const char* format, ... );
        virtual ~POTextMsg();
        virtual string messageType()const { return "POTextMsg"; };

        string  getText()const{ return m_txt.val(); }
        void    setText( const string& txt );

        virtual POMessage* clone()const;

        //==========================
        // Packable
        //==========================
        int packsize()const;
        int pack( char* buf )const;
        int unpack( char* buf );

    private:
        POString  m_txt;
};

#endif
