#include"POTypes.h"
#ifdef WIN32
#include <winsock2.h>
#else
#include<netinet/in.h>
#endif /* WIN 32 */

#include"byteswap.h"

int POString::packsize()const
{
    return sizeof(int) + m_str.size();
}

int POString::pack( char* buffer )const
{
    char* tmp = buffer;
    int size = m_str.size();
    memcpy( tmp, &size, sizeof(size) );
    tmp += sizeof(int); // support longer strings

    memcpy( tmp, m_str.c_str(), m_str.size() );
    tmp += m_str.size();
    
    return tmp - buffer;
}

int POString::unpack( char* buffer )
{
    char* tmp = buffer;
    int size;
    memcpy( &size, tmp, sizeof(size) );
    tmp += sizeof(size);
    
    m_str = string( tmp, size );
    tmp += size;
    
    return tmp - buffer;
}

int POInt::packsize()const { return sizeof(int); }
int POInt::pack( char* buffer )const
{
    int tmp = htonl(m_int);
    memcpy( buffer, &tmp, sizeof(int) );
    return sizeof(int);
}
int POInt::unpack( char* buffer )
{
    memcpy( &m_int, buffer, sizeof(int) );
    m_int = ntohl(m_int);
    return sizeof(m_int);
}
int POFloat::packsize()const { return sizeof(m_float); }
int POFloat::pack( char* buffer )const
{
    float tmp = m_float;
    host2std((void*)&tmp, sizeof(tmp) );
    memcpy( buffer, &tmp, sizeof(tmp) );
    return sizeof(tmp);
}
int POFloat::unpack( char* buffer )
{
    memcpy( &m_float, buffer, sizeof(m_float) );
    std2host((void*)&m_float, sizeof(m_float) );
    return sizeof(m_float);
}




int PODouble::packsize()const { return sizeof(m_double); }
int PODouble::pack( char* buffer )const
{
    double tmp = m_double;
    host2std((void*)&tmp, sizeof(tmp) );
    memcpy( buffer, &tmp, sizeof(tmp) );
    return sizeof(tmp);
}
int PODouble::unpack( char* buffer )
{
    memcpy( &m_double, buffer, sizeof(m_double) );
    std2host((void*)&m_double, sizeof(m_double) );
    return sizeof(m_double);
}
